#!/bin/sh

#produces the data for figure 5 in the paper, the timings given specific number of threads to the #omp parallel for num_threads directive. 
NUC_FASTA_SRC="nuc.fasta"
NUC_AWFMI_INDEX_SRC="awfmiNucIndex.awfmi"
NUM_QUERIES=1000000
QUERY_LENGTH=14

echo "Generating data for Figure 5: thread count benchmarks"
echo "----------------------data for Fig 5 Count(),  threads 1-72 ----------------"
for numThreads in {1..72}
do
 # echo "----------------------data for Fig 5 Count(), $numThreads threads ----------------"
  awfmi/search/awfmiSearch.out -f $NUC_FASTA_SRC -k $QUERY_LENGTH -i $NUC_AWFMI_INDEX_SRC -t $numThreads -n $NUM_QUERIES -c | grep "average" | awk '{print $9}'
done


echo "----------------------data for Fig 5 Locate(),  threads 1-72 ----------------"
for numThreads in {1..72}
do
  #echo "----------------------data for Fig 5 Locate(), $numThreads threads ----------------"
  awfmi/search/awfmiSearch.out -f $NUC_FASTA_SRC -k $QUERY_LENGTH -i $NUC_AWFMI_INDEX_SRC -t $numThreads -n $NUM_QUERIES | grep "average"| awk '{print $9}'
done

