#!/bin/sh

#1 for 'run these tests', 0 for don't run
#to run a locate on seqan, SA 4, all 3 of those flags must be set to 1
RUN_COUNT=1
RUN_LOCATE=1
RUN_AWFMI=1
RUN_SEQAN=1
RUN_NUC=1
RUN_AMINO=1


NUC_AWFMI_INDEX_SRC="awfmiNucIndex.awfmi"
AMINO_AWFMI_INDEX_SRC="awfmiAminoIndex.awfmi"
NUC_SEQAN_INDEX_SRC="seqanNucIndex.index"
AMINO_SEQAN_INDEX_SRC="seqanAminoIndex.index"

SEQAN_EXE="seqan3/seqanSa4.out"
AWFMI_EXE="awfmi/search/awfmiSearch.out"


#produces the data for tables 2 and 3 in the paper 
NUM_QUERIES=1000000
NUC_FASTA_SRC="nuc.fasta"
AMINO_FASTA_SRC="amino.fasta"
#NUC_SEQAN_INDEX_SRC="seqanNucIndex.index"
#AMINO_SEQAN_INDEX_SRC="seqanAminoIndex.index"
#NUC_AWFMI_INDEX_SRC="awfmiNucIndex.awfmi"
#AMINO_AWFMI_INDEX_SRC="awfmiAminoIndex.awfmi"
NUM_THREADS=1

 
echo "making data for tables 2 and 3."

if [ $RUN_LOCATE -eq "1" -a $RUN_SEQAN -eq "1" -a $RUN_NUC -eq "1" ]
then

        echo "----------------------SEQAN: table 2, Nucleotide Locate----------------"
        for queryLength in  20 18 16 14 12 11
        do
                echo "query length $queryLength:"
                $SEQAN_EXE -f $NUC_FASTA_SRC -k $queryLength -i $NUC_SEQAN_INDEX_SRC -t $NUM_THREADS -n $NUM_QUERIES | grep "average"
        done
fi


if [ $RUN_LOCATE -eq "1" -a $RUN_AWFMI -eq "1" -a $RUN_NUC -eq "1" ]
then
        echo "----------------------AWFMI: table 2, Nucleotide Locate()----------------"
        for queryLength in  20 18 16 14 12 11
        do
                echo "query length $queryLength:"
		$AWFMI_EXE -f $NUC_FASTA_SRC -k $queryLength -i $NUC_AWFMI_INDEX_SRC -t $NUM_THREADS -n $NUM_QUERIES -m | grep "average"
        done
fi


if [ $RUN_COUNT -eq "1" -a $RUN_SEQAN -eq "1" -a $RUN_NUC -eq "1" ]
then
        echo "----------------------SEQAN: table 2, Nucleotide Count()----------------"
        for queryLength in 20 18 16 14 12 11
        do
                echo "query length $queryLength:"
                $SEQAN_EXE -f $NUC_FASTA_SRC -k $queryLength -i $NUC_SEQAN_INDEX_SRC -t $NUM_THREADS -n $NUM_QUERIES -c | grep "average"
        done
fi


if [ $RUN_COUNT -eq "1" -a $RUN_AWFMI -eq "1" -a $RUN_NUC -eq "1" ]
then
	echo "----------------------AWFMI: table 2, Nucleotide Count()----------------"
	for queryLength in 20 18 16 14 12 11
	do
		echo "query length $queryLength:"
		$AWFMI_EXE -f $NUC_FASTA_SRC -k $queryLength -i $NUC_AWFMI_INDEX_SRC -t $NUM_THREADS -n $NUM_QUERIES -c | grep "average"
	done
fi


if [ $RUN_LOCATE -eq "1" -a $RUN_SEQAN -eq "1" -a $RUN_AMINO -eq "1" ]
then
        echo "----------------------SEQAN: table 3, Amino Acid Locate()----------------"
        for queryLength in 10 9 8 7 6 5
        do
                echo "query length $queryLength:"
                $SEQAN_EXE -f $AMINO_FASTA_SRC -k $queryLength -i $AMINO_SEQAN_INDEX_SRC -t $NUM_THREADS -n $NUM_QUERIES -a | grep "average"
        done
fi

if [ $RUN_LOCATE -eq "1" -a $RUN_AWFMI -eq "1" -a $RUN_AMINO -eq "1" ]
then
        echo "----------------------AWFMI: table 3, Amino Acid Locate(----------------"
        for queryLength in 10 9 8 7 6 5
        do
                echo "query length $queryLength:"
                $AWFMI_EXE -f $AMINO_FASTA_SRC -k $queryLength -i $AMINO_AWFMI_INDEX_SRC -t $NUM_THREADS -n $NUM_QUERIES | grep "average"
        done
fi


if [ $RUN_COUNT -eq "1" -a $RUN_SEQAN -eq "1" -a $RUN_AMINO -eq "1" ]
then
	echo "----------------------SEQAN: table 3, Amino Acid Count()----------------"
        for queryLength in 10 9 8 7 6 5
        do
                echo "query length $queryLength:"
		$SEQAN_EXE -f $AMINO_FASTA_SRC -k $queryLength -i $AMINO_SEQAN_INDEX_SRC -t $NUM_THREADS -n $NUM_QUERIES -a -c | grep "average"
        done
fi

if [ $RUN_COUNT -eq "1" -a $RUN_AWFMI -eq "1" -a $RUN_AMINO -eq "1" ]
then
        echo "----------------------AWFMI: table 3, Amino Acid Count()----------------"
        for queryLength in 10 9 8 7 6 5
        do
                echo "query length $queryLength:"
                $AWFMI_EXE -f $AMINO_FASTA_SRC -k $queryLength -i $AMINO_AWFMI_INDEX_SRC -t $NUM_THREADS -n $NUM_QUERIES -c | grep "average"
        done
fi




