#!/bin/sh

#produces the data for table 4 
NUM_QUERIES=1000000
NUC_FASTA_SRC="nuc.fasta"
AMINO_FASTA_SRC="amino.fasta"
NUC_SEQAN_INDEX_SRC="seqanNucIndex.index"
AMINO_SEQAN_INDEX_SRC="seqanAminoIndex.index"
NUC_AWFMI_INDEX_SRC="awfmiNucIndex.awfmi"
AMINO_AWFMI_INDEX_SRC="awfmiAminoIndex.awfmi"
NUM_THREADS=1
NUC_QUERY_LENGTH=14
AMINO_QUERY_LENGTH=6
DEFAULT_NUC_KMER_TABLE_LENGTH=12
DEFAULT_AMINO_KMER_TABLE_LENGTH=5

echo "generating data for table 5."

for compressionRatio in 1 2 4 8 16 32 64 128
do
  echo "---------------------building AWFMI index for suffix array compression ratio $compressionRatio --------------"
  INDEX_FILE_SRC="awfmiIndex_s${compressionRatio}.awfmi"
#  echo "generating index file $INDEX_FILE_SRC, table length $DEFAULT_NUC_KMER_TABLE_LENGTH"
  awfmi/build/buildIndex.out -f $NUC_FASTA_SRC -i $INDEX_FILE_SRC -s $compressionRatio -k $DEFAULT_NUC_KMER_TABLE_LENGTH | grep "average"
  echo "awfmi in memory Locate() time:"
  awfmi/search/awfmiSearch.out -f $NUC_FASTA_SRC -k $QUERY_LENGTH -i $INDEX_FILE_SRC -t $NUM_THREADS -n $NUM_QUERIES #| grep "average"
  echo "awfmi on Disk Locate() time:"
#  echo "awfmi/search/awfmiSearch.out -f $NUC_FASTA_SRC -k $QUERY_LENGTH -i $INDEX_FILE_SRC -t $NUM_THREADS -n $NUM_QUERIES -d"
  awfmi/search/awfmiSearch.out -f $NUC_FASTA_SRC -k $QUERY_LENGTH -i $INDEX_FILE_SRC -t $NUM_THREADS -n $NUM_QUERIES -d  #| grep "average"
  #removes the index when finished (these can take up a lot of memory if they all stick around)
  rm $INDEX_FILE_SRC
done


#for compressionRatio in 1 2 4 8 16 32 64 128
#do
#  echo "---------------------building Seqan3 index for suffix array compression ratio $compressionRatio --------------"
#  INDEX_FILE_SRC="memCompareSeqanIndex_s${compressionRatio}.index"
#  SEQAN_EXE_SRC="seqanSa${compressionRatio}.out"
#  seqan3/seqanIndex.out 
#  seqan3
#done
